# Generated by Django 4.1.6 on 2023-04-03 20:08

from django.db import migrations, models
import django.db.models.deletion
from django.db.migrations import RunPython


def set_work_contract_at_work_schedules(apps, schema_migration):
    WorkSchedule = apps.get_model("employees", "WorkSchedule")
    WorkingContract = apps.get_model("employees", "WorkingContract")

    # first take all initial work schedules and assign them to it's reverse contract
    for contract in WorkingContract.objects.all():
        work_schedule = contract.initial_work_schedule
        work_schedule.working_contract = contract
        work_schedule.save()

    # then look for tangling WorkSchedules and assign them to their employee's first WorkingContract, if any
    for work_schedule in WorkSchedule.objects.filter(working_contract__isnull=True):
        any_working_contract = work_schedule.employee.working_contracts.first()
        if any_working_contract:
            work_schedule.working_contract = any_working_contract
        else:
            # this is a problem. If no working contract is created per employee,
            # but working schedules are, the admin is the culprit... and must create one before
            # continuing migrations.
            raise LookupError(
                f"No WorkingContract found for employee {work_schedule.employee}. "
                f"Please create a WorkingContract before migrations can continue."
            )


def set_initial_working_schedules_at_working_contract(apps, schema_migration):
    WorkSchedule = apps.get_model("employees", "WorkSchedule")
    WorkingContract = apps.get_model("employees", "WorkingContract")

    for contract in WorkingContract.objects.all():
        first_work_schedule = contract.employee.work_schedules.first()
        if not first_work_schedule:
            # create a dummy WorkSchedule, even without WorkingTimeRanges, just to continue.
            first_work_schedule = WorkSchedule.objects.create(
                employee=contract.employee, working_contract=contract
            )
        contract.initial_work_schedule = first_work_schedule


class Migration(migrations.Migration):
    dependencies = [
        ("employees", "0006_workingcontract_employment_date"),
    ]

    operations = [
        # first add field "working_contract" with null attribute
        migrations.AddField(
            model_name="workschedule",
            name="working_contract",
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name="work_schedules",
                to="employees.workingcontract",
            ),
        ),
        # then shift all contracts' initial_work_schedule to WorkSchedules -> contract
        RunPython(
            code=set_work_contract_at_work_schedules,
            reverse_code=set_initial_working_schedules_at_working_contract,
        ),
        # # ... remove null attribute
        # migrations.AlterField(
        #     model_name="workschedule",
        #     name="working_contract",
        #     field=models.ForeignKey(
        #         on_delete=django.db.models.deletion.CASCADE,
        #         related_name="work_schedules",
        #         to="employees.workingcontract",
        #     ),
        # ),
        # fill initial_working_schedule fields with None (for reverse migrations)
        migrations.AlterField(
            model_name="workingcontract",
            name="initial_work_schedule",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="working_contract",
                to="employees.workschedule",
                default=1,  # this line here is new, and necessary to let reverse migrations run.
                # it is a bad hack, and assumes that there is a row in the WorkSchedule table
                # with the ID 1. This is VeryBad[TM], I know.
                # But it will only occur if someone tries to run the migrations in reverse order,
                # which is generally only done while developing, when something awful happens in
                # production (which will never, ever come true!), or if the sysop is nuts.
                # So I'll just keep it like it is, in full conscience that this is a possible bug.
            ),
        ),
        # and finally remove initial_work_schedule field
        migrations.RemoveField(
            model_name="workingcontract",
            name="initial_work_schedule",
        ),
    ]
